unit BMToolBar;

interface

uses
  SysUtils, Classes, Controls, ComCtrls, ImgList, Dialogs;

procedure Register;

const
  TOOLBAR_NAME = 'BookMarkToolBar';

type
  TMainModule = class(TDataModule)
    IconList: TImageList;
    procedure DataModuleDestroy(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
  private
    procedure OnSetBookmarkClick(Sender: TObject);
    procedure OnNextBookmarkClick(Sender: TObject);
  public
  end;

var
  MainModule: TMainModule;

implementation
{$R *.dfm}

uses
  ToolsAPI, PublicModule;

//*****************************************************************************
//[ T  v ]@ToolbarƂ̒ToolButton̍쐬s
//*****************************************************************************
procedure TMainModule.DataModuleCreate(Sender: TObject);
var
  IDEServices: INTAServices;
  ToolBar: TToolBar;
  ToolButton: TToolButton;
begin
  IDEServices := (BorlandIDEServices as INTAServices);
  ToolBar := IDEServices.NewToolbar(TOOLBAR_NAME, 'ݒ');
  Assert(Assigned(Toolbar), '[U`̃c[o[̍쐬Ɏs܂');
  ToolBar.Images := IconList;

  //4TrueɂStyle=tbsDividerƂȂ邪A3̐ݒ肪svɂȂ
  //4FalseɂTSpeedButton쐬݂
  ToolButton := IDEServices.AddToolButton(TOOLBAR_NAME,'SetBookmark',nil ,True) as TToolButton;
  with ToolButton do
  begin
    Style      := tbsButton;
    OnClick    := OnSetBookmarkClick;
    ImageIndex := 0;
    Hint       := '̐ݒ/';
  end;
  ToolButton := IDEServices.AddToolButton(TOOLBAR_NAME,'NextBookmark',nil ,True) as TToolButton;
  with ToolButton do
  begin
    Style      := tbsButton;
    OnClick    := OnNextBookmarkClick;
    ImageIndex := 1;
    Hint       := '̂';
  end;
  ToolButton := IDEServices.AddToolButton(TOOLBAR_NAME,'PrevBookmark',nil ,True) as TToolButton;
  with ToolButton do
  begin
    Style      := tbsButton;
    OnClick    := OnNextBookmarkClick;
    ImageIndex := 2;
    Hint       := 'Ô';
  end;

  //Ō̃{^̔pȂ΁A{^̕\ȂȂ̂Ń_~[쐬폜
  IDEServices.AddToolButton(TOOLBAR_NAME,'Dummy',nil ,True).Free;

  ToolBar.Visible := True;
end;

//*****************************************************************************
//[ T  v ]@Toolbarj
//*****************************************************************************
procedure TMainModule.DataModuleDestroy(Sender: TObject);
var
  EditToolBar: TToolBar;
begin
  EditToolBar := (BorlandIDEServices as INTAServices).ToolBar[TOOLBAR_NAME];
  if Assigned(EditToolBar) then EditToolBar.Free;
end;

//*****************************************************************************
//[Cxg]@̐ݒ/NbN
//[ T  v ]@J[\ŝ̐ݒ܂͉s
//*****************************************************************************
procedure TMainModule.OnSetBookmarkClick(Sender: TObject);
var
  BookMarkID: Integer;
  Row: Integer;
begin
  if not CheckEditView() then Exit;

  //݈ʒu
  Row := EditView.Position.Row;

  BookMarkID := GetActLineBookMarkID();
  if BookMarkID >= 0 then
  begin
    //̉
    EditView.BookmarkToggle(BookMarkID);
  end
  else
  begin
    //̐ݒ
    BookMarkID := GetUnusedBookMarkID();
    if BookMarkID < 10 then
    begin
      //s̐擪ɂݒ
      EditView.Position.Move(Row, 1);
      EditView.BookmarkRecord(BookMarkID);
    end
    else
    begin
      MessageDlg('10܂łݒł܂', mtInformation, [mbOK], 0);
    end;
  end;

  //ĕ`
  EditView.MoveViewToCursor;
  EditView.Paint;
end;

//*****************************************************************************
//[Cxg]@̂ or ÔNbN
//[ T  v ]@J[\sO܂͒̂ɃWv
//*****************************************************************************
procedure TMainModule.OnNextBookmarkClick(Sender: TObject);
var
  BookMarkID: Integer;
begin
  if not CheckEditView() then Exit;

  case (Sender as TComponent).Name[1] of
  'N': //NextBookmark
    begin
      //BookMarkID擾
      BookMarkID := GetNextBookmarkID(+1);
    end;
  'P': //PrevBookmark
    begin
      //OBookMarkID擾
      BookMarkID := GetNextBookmarkID(-1);
    end;
  else Exit;
  end;

  if BookMarkID >= 0 then
  begin
    EditView.BookmarkGoto(BookMarkID);
    EditView.MoveViewToCursor;

    //ĕ`
    EditView.Paint;
  end;
end;

//*****************************************************************************
//o^
//*****************************************************************************
procedure Register;
begin
  MainModule := TMainModule.Create(nil);
end;

//*****************************************************************************
//폜
//*****************************************************************************
procedure UnRegister;
begin
  MainModule.Free;
end;


initialization
finalization
	UnRegister;
end.
