unit PublicModule;

interface

uses
  ToolsAPI;

function CheckEditView(): Boolean;
function GetActLineBookMarkID(): Integer;
function GetUnusedBookMarkID(): Integer;
function GetNextBookmarkID(PrevOrNext: Integer): Integer;

var
  EditView: IOTAEditView;

implementation

//*****************************************************************************
//[ T  v ]@ҏWEditViewIuWFNgPrivateϐɐݒ
//[ ߂l ]@ҏWEditViewIuWFNg̎擾ɐ
//*****************************************************************************
function CheckEditView: Boolean;
begin
  Result := False;
  if (BorlandIDEServices as IOTAModuleServices).ModuleCount = 0 then Exit;
  EditView := (BorlandIDEServices as IOTAEditorServices).TopView;
  Result := Assigned(EditView);
end;

//*****************************************************************************
//[ T  v ]@J[\̂sBookMarkID擾(ȂƂ-1)
//[ ߂l ]@BookMarkID
//*****************************************************************************
function GetActLineBookMarkID(): Integer;
var
  i: Integer;
  Row: Integer;
begin
  Result := -1;
  Row := EditView.Position.Row;

  //ubN}[N[v
  for i := 0 to 9 do
  begin
    if Row = EditView.BookmarkPos[i].Line then
    begin
      Result := i;
      Exit;
    end;
  end;
end;

//*****************************************************************************
//[ T  v ]@gpĂȂŏBookMarkID擾(ׂĎgpς݂̎10)
//[ ߂l ]@BookMarkID
//*****************************************************************************
function GetUnusedBookMarkID(): Integer;
var
  i: Integer;
begin
  Result := 10;

  //ubN}[N[v
  for i := 0 to 9 do
  begin
    if EditView.BookmarkPos[i].Line = 0 then
    begin
      Result := i;
      Exit;
    end;
  end;
end;

//*****************************************************************************
//[ T  v ]@J[\s̒O܂͒Bookmark擾(ȂƂ-1)
//[    ]@PrevOrNext:-1=OA+1:
//[ ߂l ]@BookMarkID
//*****************************************************************************
function GetNextBookmarkID(PrevOrNext: Integer): Integer;
  function SerchNextBookmarkID(ActRow: Integer): Integer;
  var
    i: Integer;
    BookRow, Row: Integer;
  begin
    Result := -1;
    if PrevOrNext < 0 then  Row := 0
                      else  Row := EditView.Position.LastRow + 1;
    //ubN}[N[v
    for i := 0 to 9 do
    begin
      BookRow := EditView.BookmarkPos[i].Line;
      if BookRow > 0 then
      begin
        if (PrevOrNext < 0) and (BookRow < ActRow) then
        begin
          if BookRow > Row then
          begin
            Row := BookRow;
            Result := i;
          end;
        end
        else if (PrevOrNext > 0) and (BookRow > ActRow) then
        begin
          if BookRow < Row then
          begin
            Row := BookRow;
            Result := i;
          end;
        end;
      end;
    end;
  end;
var
  ActRow: Integer;
begin
  ActRow := EditView.Position.Row;
  Result := SerchNextBookmarkID(ActRow);
  if Result >= 0 then Exit;

  //ȂA܂Ԃčő܂͍ŏBookmarkT
  if PrevOrNext < 0 then  ActRow := EditView.Position.LastRow + 1
                    else  ActRow := 0;
  Result := SerchNextBookmarkID(ActRow);
end;

end.
